/* 
 * 
 * .rive.js brain files get loaded by the live assistant when aeternum UI loads. When chatting, the assistant will first look for local rules that match that message and if it finds one it will answer with that, otherwise will proceed with sending the message to the oobabooga AI if it's active
 * 
 *
 * 
 * between `` add normal rivescript rules https://www.rivescript.com/docs/tutorial  https://www.rivescript.com/try, lots of examples there!
 * 
 * At the end you can also add javascript function that get called if the answer has then like {js}function_name(RIVE_chat){/js}.
 * That javascript part gets then replaced with what the function returns.
 * If the input pattern has * or (variant1|variant2), the pattern found will be in variables <star1>,<star2>,..,<starN> where the number is the occurance number, 1st, 2nd, etc.
 * Those can be sent to to javascript.
 * 
 * IMPORTANT! for js function copy paste the structure: inside the {js}{/js} the function has to have RIVE_chat as the first parameter, and to end with );.
 *  Don't stack up js inside {js}{/js}, call a single function there. Then when declaring the function make sure there's a payload argument as well. RIVE_chat & payload are necessary, and in between you can add extra parameters that you want. When done the function must do callback(answer, payload), answer can be an empty string. Calling that will replace the "{js}..{/js}" part with the answer
 * 
 */


RIVESCRIPTS.push(`

+ demo say something random
- This {random}message|sentence{/random} has a random word.
- No. 
- something random



+ demo time
- {js}brain_debug_time(RIVE_chat);{/js}



+ demo calculate * [please]
- {random}It's|It is|That's|Easy.{/random} {js}brain_math_calculate(RIVE_chat,"<star1>");{/js}{random}.|!{/random}



+ demo async * * *
- Delayed chat responses {js}brain_debug_async(RIVE_chat,1, <star1>);{/js}, {js}brain_debug_async(RIVE_chat,2, <star2>);{/js} , {js}brain_debug_async(RIVE_chat,3, <star3>);{/js}


+ demo こんにちは
- こんにちは！



`);


// adds current time in the answer
function brain_debug_time(callback, payload){
    var d = new Date();
    var answer = d.toLocaleTimeString();  
    callback(answer, payload);
}



// calculate formula example
function brain_math_calculate(callback,formula, payload){
    var answer = "";
    formula= RIVE.sanitize(formula,true);
    try{
        answer = eval(formula);
    } catch(error){
        answer = "I don't know." + formula
    };
    callback(answer, payload)
}

// async call example: when finished just call callback(answer, payload);, if there are multiple items waiting, the response should wait for all to finish
// In the example  the command receives 3 numbers, like "demo async 1 2 3" and for each of the numbers it pauses for that number of seconds, so the response in this example comes after 3 seconds (the biggest delay)
function brain_debug_async(callback, id, delay, payload){
    var answer = parseInt(delay)*1000;
    setTimeout(function(){
        callback(answer+" ms", payload);
    }, answer);
}

