﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class ConstructAmbientLight : MVRScript {
		
		bool sceneLoaded = false;
		public override void Init() {

			InvokeRepeating("UpdateSecond", 1f, 1f);
			InvokeRepeating("UpdateConstant", 1f, 1f / 30f);
			InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);
			SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
		}

	
		void Start() {
			UpdateAmbientLight_p67();
		}

	
		void Update() {
		
		}

	
		void FixedUpdate() {
		
		}
		void UpdateSecond()
		{
			if (IsDisabled()) return;
			UpdateAmbientLight_p67();

		}
		void UpdateConstant()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant5()
		{
			if (IsDisabled()) return;

		}
		void OnDestroy()
		{
			CancelInvoke();
			SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
		}

		void OnSceneLoaded()
		{
			sceneLoaded = true;
		}
		bool IsDisabled()
        {
			if (!enabledJSON.val)
			{
				return true;
			}
			return false;
		}

		void UpdateAmbientLight_p67()
		{
			var ambientColor = new Color(123f / 255f, 123f / 255f, 123f / 255f);
			if (RenderSettings.ambientLight != ambientColor)
			{
				RenderSettings.ambientLight = ambientColor;
			}
		}
	}
}