using System;
using UnityEngine;


namespace SPQR
{

    public class Colorworks
    {

        public Colorworks(){
        }

        public Color GetColorMainPurple_p67(float opacity = 1f)
        {
            return new Color(156f/255f, 35f/255f, 187f/255f, opacity);
        }
        
        public Color GetColorDeepPurple_p67()
        {
            return new Color(0.427f, 0.035f, 0.517f);
        }
        public Color GetColorMidPurple_p67()
        {
            return new Color(0.576f, 0.424f, 0.643f);
        }
        public Color GetColorLightPurple_p67()
        {
            return new Color(0.631f, 0.549f, 0.667f);
        }
        public Color GetColorDark_p67()
        {
            return new Color(0.1f, 0.1f, 0.1f);
        }
        public Color GetColorLight_p67()
        {
            return new Color(1f, 1f, 1f);
        }

        public HSVColor GetColorQuadrantToplight_p67(int i)
        {
            if (i == 1) return SPQRUtils.GetColor_p67(112f / 255f, 200f / 255f, 255f / 255f);
            if (i == 2) return SPQRUtils.GetColor_p67(255f / 255f, 112f / 255f, 112f / 255f);
            if (i == 3) return SPQRUtils.GetColor_p67(255f / 255f, 255f / 255f, 255f / 255f);
            return SPQRUtils.GetColor_p67(112f / 255f, 255f / 255f, 121f / 255f);
        }
        public HSVColor GetColorQuadrantBackground_p67(int i)
        {
            if (i == 1) return GetColorQuadrantBackground1_p67();
            if (i == 2) return GetColorQuadrantBackground2_p67();
            if (i == 3) return GetColorQuadrantBackground3_p67();
            return GetColorQuadrantBackground4_p67();
        }

        public HSVColor GetColorQuadrantBackground1_p67()
        {
            return SPQRUtils.GetColor_p67(82f/255f, 233f/255f, 255f/255f);
        }
        public HSVColor GetColorQuadrantBackground2_p67()
        {
            return SPQRUtils.GetColor_p67(255f / 255f, 39f / 255f, 86f / 255f);
        }
        public HSVColor GetColorQuadrantBackground3_p67()
        {
            return SPQRUtils.GetColor_p67(0f / 255f, 0f / 255f, 0f / 255f);
        }
        public HSVColor GetColorQuadrantBackground4_p67()
        {
            return SPQRUtils.GetColor_p67(31f / 255f, 253f / 255f, 31f / 255f);
        }

    }
}