using System;
using UnityEngine;
using System.Text.RegularExpressions;
using System.Collections;
using System.Linq;
using System.Collections.Generic;

namespace SPQR
{

    public class TextHelper
    {
        public static string TextReplaceWithRandomValue_p67(string input)
        {
            var regex = new Regex(@"\[\[([^\]]+)\]\]");
            var random = new System.Random();

            return regex.Replace(input, match =>
            {
                var options = match.Groups[1].Value.Split('|');
                var randomOption = options[random.Next(options.Length)];
                return randomOption;
            });
        }

        public static string GetRandomFromMap(Dictionary<string, string> map, Dictionary<string, string> options = null)
        {
            int randomIndex = UnityEngine.Random.Range(0, map.Count);
            return map.Keys.ElementAt(randomIndex);
        }


    }

}